send-email: don't use Mail::Address, even if available
[git.git] / git-submodule.sh
blobe131760eecf944aee97e18a68ab1f171fc0e1d1b
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
17 OPTIONS_SPEC=
18 SUBDIRECTORY_OK=Yes
19 . git-sh-setup
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
25 # Tell the rest of git that any URLs we get don't come
26 # directly from the user, so it can apply policy as appropriate.
27 GIT_PROTOCOL_FROM_USER=0
28 export GIT_PROTOCOL_FROM_USER
30 command=
31 branch=
32 force=
33 reference=
34 cached=
35 recursive=
36 init=
37 files=
38 remote=
39 nofetch=
40 update=
41 prefix=
42 custom_name=
43 depth=
44 progress=
46 die_if_unmatched ()
48 if test "$1" = "#unmatched"
49 then
50 exit ${2:-1}
55 # Print a submodule configuration setting
57 # $1 = submodule name
58 # $2 = option name
59 # $3 = default value
61 # Checks in the usual git-config places first (for overrides),
62 # otherwise it falls back on .gitmodules. This allows you to
63 # distribute project-wide defaults in .gitmodules, while still
64 # customizing individual repositories if necessary. If the option is
65 # not in .gitmodules either, print a default value.
67 get_submodule_config () {
68 name="$1"
69 option="$2"
70 default="$3"
71 value=$(git config submodule."$name"."$option")
72 if test -z "$value"
73 then
74 value=$(git config -f .gitmodules submodule."$name"."$option")
76 printf '%s' "${value:-$default}"
79 isnumber()
81 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
84 # Sanitize the local git environment for use within a submodule. We
85 # can't simply use clear_local_git_env since we want to preserve some
86 # of the settings from GIT_CONFIG_PARAMETERS.
87 sanitize_submodule_env()
89 save_config=$GIT_CONFIG_PARAMETERS
90 clear_local_git_env
91 GIT_CONFIG_PARAMETERS=$save_config
92 export GIT_CONFIG_PARAMETERS
96 # Add a new submodule to the working tree, .gitmodules and the index
98 # $@ = repo path
100 # optional branch is stored in global branch variable
102 cmd_add()
104 # parse $args after "submodule ... add".
105 reference_path=
106 while test $# -ne 0
108 case "$1" in
109 -b | --branch)
110 case "$2" in '') usage ;; esac
111 branch=$2
112 shift
114 -f | --force)
115 force=$1
117 -q|--quiet)
118 GIT_QUIET=1
120 --reference)
121 case "$2" in '') usage ;; esac
122 reference_path=$2
123 shift
125 --reference=*)
126 reference_path="${1#--reference=}"
128 --name)
129 case "$2" in '') usage ;; esac
130 custom_name=$2
131 shift
133 --depth)
134 case "$2" in '') usage ;; esac
135 depth="--depth=$2"
136 shift
138 --depth=*)
139 depth=$1
142 shift
143 break
146 usage
149 break
151 esac
152 shift
153 done
155 if test -n "$reference_path"
156 then
157 is_absolute_path "$reference_path" ||
158 reference_path="$wt_prefix$reference_path"
160 reference="--reference=$reference_path"
163 repo=$1
164 sm_path=$2
166 if test -z "$sm_path"; then
167 sm_path=$(printf '%s\n' "$repo" |
168 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
171 if test -z "$repo" || test -z "$sm_path"; then
172 usage
175 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
177 # assure repo is absolute or relative to parent
178 case "$repo" in
179 ./*|../*)
180 test -z "$wt_prefix" ||
181 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
183 # dereference source url relative to parent's url
184 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
186 *:*|/*)
187 # absolute url
188 realrepo=$repo
191 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
193 esac
195 # normalize path:
196 # multiple //; leading ./; /./; /../; trailing /
197 sm_path=$(printf '%s/\n' "$sm_path" |
198 sed -e '
199 s|//*|/|g
200 s|^\(\./\)*||
201 s|/\(\./\)*|/|g
202 :start
203 s|\([^/]*\)/\.\./||
204 tstart
205 s|/*$||
207 if test -z "$force"
208 then
209 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
210 die "$(eval_gettext "'\$sm_path' already exists in the index")"
211 else
212 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
213 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
216 if test -z "$force" &&
217 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
218 then
219 eval_gettextln "The following path is ignored by one of your .gitignore files:
220 \$sm_path
221 Use -f if you really want to add it." >&2
222 exit 1
225 if test -n "$custom_name"
226 then
227 sm_name="$custom_name"
228 else
229 sm_name="$sm_path"
232 # perhaps the path exists and is already a git repo, else clone it
233 if test -e "$sm_path"
234 then
235 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
236 then
237 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
238 else
239 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
242 else
243 if test -d ".git/modules/$sm_name"
244 then
245 if test -z "$force"
246 then
247 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
248 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
249 die "$(eval_gettextln "\
250 If you want to reuse this local git directory instead of cloning again from
251 \$realrepo
252 use the '--force' option. If the local git directory is not the correct repo
253 or you are unsure what this means choose another name with the '--name' option.")"
254 else
255 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
258 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
260 sanitize_submodule_env
261 cd "$sm_path" &&
262 # ash fails to wordsplit ${branch:+-b "$branch"...}
263 case "$branch" in
264 '') git checkout -f -q ;;
265 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
266 esac
267 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
269 git config submodule."$sm_name".url "$realrepo"
271 git add --no-warn-embedded-repo $force "$sm_path" ||
272 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
274 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
275 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
276 if test -n "$branch"
277 then
278 git config -f .gitmodules submodule."$sm_name".branch "$branch"
279 fi &&
280 git add --force .gitmodules ||
281 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
283 # NEEDSWORK: In a multi-working-tree world, this needs to be
284 # set in the per-worktree config.
285 if git config --get submodule.active >/dev/null
286 then
287 # If the submodule being adding isn't already covered by the
288 # current configured pathspec, set the submodule's active flag
289 if ! git submodule--helper is-active "$sm_path"
290 then
291 git config submodule."$sm_name".active "true"
293 else
294 git config submodule."$sm_name".active "true"
299 # Execute an arbitrary command sequence in each checked out
300 # submodule
302 # $@ = command to execute
304 cmd_foreach()
306 # parse $args after "submodule ... foreach".
307 while test $# -ne 0
309 case "$1" in
310 -q|--quiet)
311 GIT_QUIET=1
313 --recursive)
314 recursive=1
317 usage
320 break
322 esac
323 shift
324 done
326 toplevel=$(pwd)
328 # dup stdin so that it can be restored when running the external
329 # command in the subshell (and a recursive call to this function)
330 exec 3<&0
333 git submodule--helper list --prefix "$wt_prefix" ||
334 echo "#unmatched" $?
336 while read -r mode sha1 stage sm_path
338 die_if_unmatched "$mode" "$sha1"
339 if test -e "$sm_path"/.git
340 then
341 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
342 say "$(eval_gettext "Entering '\$displaypath'")"
343 name=$(git submodule--helper name "$sm_path")
345 prefix="$prefix$sm_path/"
346 sanitize_submodule_env
347 cd "$sm_path" &&
348 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
349 # we make $path available to scripts ...
350 path=$sm_path &&
351 if test $# -eq 1
352 then
353 eval "$1"
354 else
355 "$@"
356 fi &&
357 if test -n "$recursive"
358 then
359 cmd_foreach "--recursive" "$@"
361 ) <&3 3<&- ||
362 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
364 done
368 # Register submodules in .git/config
370 # $@ = requested paths (default to all)
372 cmd_init()
374 # parse $args after "submodule ... init".
375 while test $# -ne 0
377 case "$1" in
378 -q|--quiet)
379 GIT_QUIET=1
382 shift
383 break
386 usage
389 break
391 esac
392 shift
393 done
395 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
399 # Unregister submodules from .git/config and remove their work tree
401 cmd_deinit()
403 # parse $args after "submodule ... deinit".
404 deinit_all=
405 while test $# -ne 0
407 case "$1" in
408 -f|--force)
409 force=$1
411 -q|--quiet)
412 GIT_QUIET=1
414 --all)
415 deinit_all=t
418 shift
419 break
422 usage
425 break
427 esac
428 shift
429 done
431 if test -n "$deinit_all" && test "$#" -ne 0
432 then
433 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
434 usage
436 if test $# = 0 && test -z "$deinit_all"
437 then
438 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
442 git submodule--helper list --prefix "$wt_prefix" "$@" ||
443 echo "#unmatched" $?
445 while read -r mode sha1 stage sm_path
447 die_if_unmatched "$mode" "$sha1"
448 name=$(git submodule--helper name "$sm_path") || exit
450 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
452 # Remove the submodule work tree (unless the user already did it)
453 if test -d "$sm_path"
454 then
455 # Protect submodules containing a .git directory
456 if test -d "$sm_path/.git"
457 then
458 die "$(eval_gettext "\
459 Submodule work tree '\$displaypath' contains a .git directory
460 (use 'rm -rf' if you really want to remove it including all of its history)")"
463 if test -z "$force"
464 then
465 git rm -qn "$sm_path" ||
466 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
468 rm -rf "$sm_path" &&
469 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
470 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
473 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
475 # Remove the .git/config entries (unless the user already did it)
476 if test -n "$(git config --get-regexp submodule."$name\.")"
477 then
478 # Remove the whole section so we have a clean state when
479 # the user later decides to init this submodule again
480 url=$(git config submodule."$name".url)
481 git config --remove-section submodule."$name" 2>/dev/null &&
482 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
484 done
487 is_tip_reachable () (
488 sanitize_submodule_env &&
489 cd "$1" &&
490 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
491 test -z "$rev"
494 fetch_in_submodule () (
495 sanitize_submodule_env &&
496 cd "$1" &&
497 case "$2" in
499 git fetch ;;
501 shift
502 git fetch $(get_default_remote) "$@" ;;
503 esac
507 # Update each submodule path to correct revision, using clone and checkout as needed
509 # $@ = requested paths (default to all)
511 cmd_update()
513 # parse $args after "submodule ... update".
514 while test $# -ne 0
516 case "$1" in
517 -q|--quiet)
518 GIT_QUIET=1
520 --progress)
521 progress="--progress"
523 -i|--init)
524 init=1
526 --remote)
527 remote=1
529 -N|--no-fetch)
530 nofetch=1
532 -f|--force)
533 force=$1
535 -r|--rebase)
536 update="rebase"
538 --reference)
539 case "$2" in '') usage ;; esac
540 reference="--reference=$2"
541 shift
543 --reference=*)
544 reference="$1"
546 -m|--merge)
547 update="merge"
549 --recursive)
550 recursive=1
552 --checkout)
553 update="checkout"
555 --recommend-shallow)
556 recommend_shallow="--recommend-shallow"
558 --no-recommend-shallow)
559 recommend_shallow="--no-recommend-shallow"
561 --depth)
562 case "$2" in '') usage ;; esac
563 depth="--depth=$2"
564 shift
566 --depth=*)
567 depth=$1
569 -j|--jobs)
570 case "$2" in '') usage ;; esac
571 jobs="--jobs=$2"
572 shift
574 --jobs=*)
575 jobs=$1
578 shift
579 break
582 usage
585 break
587 esac
588 shift
589 done
591 if test -n "$init"
592 then
593 cmd_init "--" "$@" || return
597 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
598 ${progress:+"$progress"} \
599 ${wt_prefix:+--prefix "$wt_prefix"} \
600 ${prefix:+--recursive-prefix "$prefix"} \
601 ${update:+--update "$update"} \
602 ${reference:+"$reference"} \
603 ${depth:+--depth "$depth"} \
604 ${recommend_shallow:+"$recommend_shallow"} \
605 ${jobs:+$jobs} \
606 "$@" || echo "#unmatched" $?
607 } | {
608 err=
609 while read -r mode sha1 stage just_cloned sm_path
611 die_if_unmatched "$mode" "$sha1"
613 name=$(git submodule--helper name "$sm_path") || exit
614 url=$(git config submodule."$name".url)
615 if ! test -z "$update"
616 then
617 update_module=$update
618 else
619 update_module=$(git config submodule."$name".update)
620 if test -z "$update_module"
621 then
622 update_module="checkout"
626 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
628 if test $just_cloned -eq 1
629 then
630 subsha1=
631 case "$update_module" in
632 merge | rebase | none)
633 update_module=checkout ;;
634 esac
635 else
636 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
637 git rev-parse --verify HEAD) ||
638 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
641 if test -n "$remote"
642 then
643 branch=$(git submodule--helper remote-branch "$sm_path")
644 if test -z "$nofetch"
645 then
646 # Fetch remote before determining tracking $sha1
647 fetch_in_submodule "$sm_path" $depth ||
648 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
650 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
651 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
652 git rev-parse --verify "${remote_name}/${branch}") ||
653 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
656 if test "$subsha1" != "$sha1" || test -n "$force"
657 then
658 subforce=$force
659 # If we don't already have a -f flag and the submodule has never been checked out
660 if test -z "$subsha1" && test -z "$force"
661 then
662 subforce="-f"
665 if test -z "$nofetch"
666 then
667 # Run fetch only if $sha1 isn't present or it
668 # is not reachable from a ref.
669 is_tip_reachable "$sm_path" "$sha1" ||
670 fetch_in_submodule "$sm_path" $depth ||
671 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
673 # Now we tried the usual fetch, but $sha1 may
674 # not be reachable from any of the refs
675 is_tip_reachable "$sm_path" "$sha1" ||
676 fetch_in_submodule "$sm_path" $depth "$sha1" ||
677 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
680 must_die_on_failure=
681 case "$update_module" in
682 checkout)
683 command="git checkout $subforce -q"
684 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
685 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
687 rebase)
688 command="git rebase"
689 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
690 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
691 must_die_on_failure=yes
693 merge)
694 command="git merge"
695 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
696 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
697 must_die_on_failure=yes
700 command="${update_module#!}"
701 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
702 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
703 must_die_on_failure=yes
706 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
707 esac
709 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
710 then
711 say "$say_msg"
712 elif test -n "$must_die_on_failure"
713 then
714 die_with_status 2 "$die_msg"
715 else
716 err="${err};$die_msg"
717 continue
721 if test -n "$recursive"
722 then
724 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
725 wt_prefix=
726 sanitize_submodule_env
727 cd "$sm_path" &&
728 eval cmd_update
730 res=$?
731 if test $res -gt 0
732 then
733 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
734 if test $res -ne 2
735 then
736 err="${err};$die_msg"
737 continue
738 else
739 die_with_status $res "$die_msg"
743 done
745 if test -n "$err"
746 then
747 OIFS=$IFS
748 IFS=';'
749 for e in $err
751 if test -n "$e"
752 then
753 echo >&2 "$e"
755 done
756 IFS=$OIFS
757 exit 1
762 set_name_rev () {
763 revname=$( (
764 sanitize_submodule_env
765 cd "$1" && {
766 git describe "$2" 2>/dev/null ||
767 git describe --tags "$2" 2>/dev/null ||
768 git describe --contains "$2" 2>/dev/null ||
769 git describe --all --always "$2"
772 test -z "$revname" || revname=" ($revname)"
775 # Show commit summary for submodules in index or working tree
777 # If '--cached' is given, show summary between index and given commit,
778 # or between working tree and given commit
780 # $@ = [commit (default 'HEAD'),] requested paths (default all)
782 cmd_summary() {
783 summary_limit=-1
784 for_status=
785 diff_cmd=diff-index
787 # parse $args after "submodule ... summary".
788 while test $# -ne 0
790 case "$1" in
791 --cached)
792 cached="$1"
794 --files)
795 files="$1"
797 --for-status)
798 for_status="$1"
800 -n|--summary-limit)
801 summary_limit="$2"
802 isnumber "$summary_limit" || usage
803 shift
805 --summary-limit=*)
806 summary_limit="${1#--summary-limit=}"
807 isnumber "$summary_limit" || usage
810 shift
811 break
814 usage
817 break
819 esac
820 shift
821 done
823 test $summary_limit = 0 && return
825 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
826 then
827 head=$rev
828 test $# = 0 || shift
829 elif test -z "$1" || test "$1" = "HEAD"
830 then
831 # before the first commit: compare with an empty tree
832 head=$(git hash-object -w -t tree --stdin </dev/null)
833 test -z "$1" || shift
834 else
835 head="HEAD"
838 if [ -n "$files" ]
839 then
840 test -n "$cached" &&
841 die "$(gettext "The --cached option cannot be used with the --files option")"
842 diff_cmd=diff-files
843 head=
846 cd_to_toplevel
847 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
848 # Get modified modules cared by user
849 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
850 sane_egrep '^:([0-7]* )?160000' |
851 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
853 # Always show modules deleted or type-changed (blob<->module)
854 if test "$status" = D || test "$status" = T
855 then
856 printf '%s\n' "$sm_path"
857 continue
859 # Respect the ignore setting for --for-status.
860 if test -n "$for_status"
861 then
862 name=$(git submodule--helper name "$sm_path")
863 ignore_config=$(get_submodule_config "$name" ignore none)
864 test $status != A && test $ignore_config = all && continue
866 # Also show added or modified modules which are checked out
867 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
868 printf '%s\n' "$sm_path"
869 done
872 test -z "$modules" && return
874 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
875 sane_egrep '^:([0-7]* )?160000' |
876 cut -c2- |
877 while read -r mod_src mod_dst sha1_src sha1_dst status name
879 if test -z "$cached" &&
880 test $sha1_dst = 0000000000000000000000000000000000000000
881 then
882 case "$mod_dst" in
883 160000)
884 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
886 100644 | 100755 | 120000)
887 sha1_dst=$(git hash-object $name)
889 000000)
890 ;; # removed
892 # unexpected type
893 eval_gettextln "unexpected mode \$mod_dst" >&2
894 continue ;;
895 esac
897 missing_src=
898 missing_dst=
900 test $mod_src = 160000 &&
901 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
902 missing_src=t
904 test $mod_dst = 160000 &&
905 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
906 missing_dst=t
908 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
910 total_commits=
911 case "$missing_src,$missing_dst" in
913 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
916 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
918 t,t)
919 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
922 errmsg=
923 total_commits=$(
924 if test $mod_src = 160000 && test $mod_dst = 160000
925 then
926 range="$sha1_src...$sha1_dst"
927 elif test $mod_src = 160000
928 then
929 range=$sha1_src
930 else
931 range=$sha1_dst
933 GIT_DIR="$name/.git" \
934 git rev-list --first-parent $range -- | wc -l
936 total_commits=" ($(($total_commits + 0)))"
938 esac
940 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
941 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
942 if test $status = T
943 then
944 blob="$(gettext "blob")"
945 submodule="$(gettext "submodule")"
946 if test $mod_dst = 160000
947 then
948 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
949 else
950 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
952 else
953 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
955 if test -n "$errmsg"
956 then
957 # Don't give error msg for modification whose dst is not submodule
958 # i.e. deleted or changed to blob
959 test $mod_dst = 160000 && echo "$errmsg"
960 else
961 if test $mod_src = 160000 && test $mod_dst = 160000
962 then
963 limit=
964 test $summary_limit -gt 0 && limit="-$summary_limit"
965 GIT_DIR="$name/.git" \
966 git log $limit --pretty='format: %m %s' \
967 --first-parent $sha1_src...$sha1_dst
968 elif test $mod_dst = 160000
969 then
970 GIT_DIR="$name/.git" \
971 git log --pretty='format: > %s' -1 $sha1_dst
972 else
973 GIT_DIR="$name/.git" \
974 git log --pretty='format: < %s' -1 $sha1_src
976 echo
978 echo
979 done
982 # List all submodules, prefixed with:
983 # - submodule not initialized
984 # + different revision checked out
986 # If --cached was specified the revision in the index will be printed
987 # instead of the currently checked out revision.
989 # $@ = requested paths (default to all)
991 cmd_status()
993 # parse $args after "submodule ... status".
994 while test $# -ne 0
996 case "$1" in
997 -q|--quiet)
998 GIT_QUIET=1
1000 --cached)
1001 cached=1
1003 --recursive)
1004 recursive=1
1007 shift
1008 break
1011 usage
1014 break
1016 esac
1017 shift
1018 done
1021 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1022 echo "#unmatched" $?
1024 while read -r mode sha1 stage sm_path
1026 die_if_unmatched "$mode" "$sha1"
1027 name=$(git submodule--helper name "$sm_path") || exit
1028 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1029 if test "$stage" = U
1030 then
1031 say "U$sha1 $displaypath"
1032 continue
1034 if ! git submodule--helper is-active "$sm_path" ||
1036 ! test -d "$sm_path"/.git &&
1037 ! test -f "$sm_path"/.git
1039 then
1040 say "-$sha1 $displaypath"
1041 continue;
1043 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1044 then
1045 set_name_rev "$sm_path" "$sha1"
1046 say " $sha1 $displaypath$revname"
1047 else
1048 if test -z "$cached"
1049 then
1050 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1052 set_name_rev "$sm_path" "$sha1"
1053 say "+$sha1 $displaypath$revname"
1056 if test -n "$recursive"
1057 then
1059 prefix="$displaypath/"
1060 sanitize_submodule_env
1061 wt_prefix=
1062 cd "$sm_path" &&
1063 eval cmd_status
1064 ) ||
1065 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1067 done
1070 # Sync remote urls for submodules
1071 # This makes the value for remote.$remote.url match the value
1072 # specified in .gitmodules.
1074 cmd_sync()
1076 while test $# -ne 0
1078 case "$1" in
1079 -q|--quiet)
1080 GIT_QUIET=1
1081 shift
1083 --recursive)
1084 recursive=1
1085 shift
1088 shift
1089 break
1092 usage
1095 break
1097 esac
1098 done
1099 cd_to_toplevel
1101 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1102 echo "#unmatched" $?
1104 while read -r mode sha1 stage sm_path
1106 die_if_unmatched "$mode" "$sha1"
1108 # skip inactive submodules
1109 if ! git submodule--helper is-active "$sm_path"
1110 then
1111 continue
1114 name=$(git submodule--helper name "$sm_path")
1115 url=$(git config -f .gitmodules --get submodule."$name".url)
1117 # Possibly a url relative to parent
1118 case "$url" in
1119 ./*|../*)
1120 # rewrite foo/bar as ../.. to find path from
1121 # submodule work tree to superproject work tree
1122 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1123 # guarantee a trailing /
1124 up_path=${up_path%/}/ &&
1125 # path from submodule work tree to submodule origin repo
1126 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1127 # path from superproject work tree to submodule origin repo
1128 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1131 sub_origin_url="$url"
1132 super_config_url="$url"
1134 esac
1136 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1137 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1138 git config submodule."$name".url "$super_config_url"
1140 if test -e "$sm_path"/.git
1141 then
1143 sanitize_submodule_env
1144 cd "$sm_path"
1145 remote=$(get_default_remote)
1146 git config remote."$remote".url "$sub_origin_url"
1148 if test -n "$recursive"
1149 then
1150 prefix="$prefix$sm_path/"
1151 eval cmd_sync
1155 done
1158 cmd_absorbgitdirs()
1160 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1163 # This loop parses the command line arguments to find the
1164 # subcommand name to dispatch. Parsing of the subcommand specific
1165 # options are primarily done by the subcommand implementations.
1166 # Subcommand specific options such as --branch and --cached are
1167 # parsed here as well, for backward compatibility.
1169 while test $# != 0 && test -z "$command"
1171 case "$1" in
1172 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
1173 command=$1
1175 -q|--quiet)
1176 GIT_QUIET=1
1178 -b|--branch)
1179 case "$2" in
1181 usage
1183 esac
1184 branch="$2"; shift
1186 --cached)
1187 cached="$1"
1190 break
1193 usage
1196 break
1198 esac
1199 shift
1200 done
1202 # No command word defaults to "status"
1203 if test -z "$command"
1204 then
1205 if test $# = 0
1206 then
1207 command=status
1208 else
1209 usage
1213 # "-b branch" is accepted only by "add"
1214 if test -n "$branch" && test "$command" != add
1215 then
1216 usage
1219 # "--cached" is accepted only by "status" and "summary"
1220 if test -n "$cached" && test "$command" != status && test "$command" != summary
1221 then
1222 usage
1225 "cmd_$command" "$@"